package com.sun.jndi.toolkit.url;

import java.net.MalformedURLException;

public class Uri
{
    protected String uri;
    protected String scheme;
    protected String host;
    protected int port;
    protected boolean hasAuthority;
    protected String path;
    protected String query;
    
    public Uri(String s) throws MalformedURLException {
        this.host = null;
        this.port = -1;
        this.query = null;
        this.init(s);
    }
    
    protected Uri() {
        this.host = null;
        this.port = -1;
        this.query = null;
    }
    
    protected void init(String uri) throws MalformedURLException {
        this.parse(this.uri = uri);
    }
    
    public String getScheme() {
        return this.scheme;
    }
    
    public String getHost() {
        return this.host;
    }
    
    public int getPort() {
        return this.port;
    }
    
    public String getPath() {
        return this.path;
    }
    
    public String getQuery() {
        return this.query;
    }
    
    @Override
    public String toString() {
        return this.uri;
    }
    
    private void parse(String s) throws MalformedURLException {
        int index = s.indexOf(58);
        if (index < 0) {
            throw new MalformedURLException("Invalid URI: " + s);
        }
        this.scheme = s.substring(0, index);
        ++index;
        this.hasAuthority = s.startsWith("//", index);
        if (this.hasAuthority) {
            index += 2;
            int endIndex = s.indexOf(47, index);
            if (endIndex < 0) {
                endIndex = s.length();
            }
            int n;
            if (s.startsWith("[", index)) {
                int index3 = s.indexOf(93, index + 1);
                if (index3 < 0 || index3 > endIndex) {
                    throw new MalformedURLException("Invalid URI: " + s);
                }
                this.host = s.substring(index, index3 + 1);
                n = index3 + 1;
            }
            else {
                int index2 = s.indexOf(58, index);
                index2 = ((index2 < 0 || index2 > endIndex) ? endIndex : index2);
                if (index < index2) {
                    this.host = s.substring(index, index2);
                }
                n = index2;
            }
            if (n + 1 < endIndex && s.startsWith(":", n)) {
                ++n;
                this.port = Integer.parseInt(s.substring(n, endIndex));
            }
            index = endIndex;
        }
        int index4 = s.indexOf(63, index);
        if (index4 < 0) {
            this.path = s.substring(index);
        }
        else {
            this.path = s.substring(index, index4);
            this.query = s.substring(index4);
        }
        return;
    }
}
